<?
		$rubrique = 3;
		$meta_description = "Manipulation des listes doublement chanes en C";
		$meta_keywords = "langage, C, listes, doublement, chanes, tutoriel, tutorial, cour, programmation, informatique";
		$titre_page = "Les structures de donnes en C : les listes doublement chanes.";
		$urlCss = "./article.css";
		$xhtml=true;
        
			$Auteur="Nicolas Joseph";
			$Licence="2";
			$Annee="2006";
		
		$dateBrute['date'] = '20 Juillet 2005';
		$dateBrute['miseajour'] = '';
		
				$topicType = 'Whitepaper';
			include("$DOCUMENT_ROOT/template/entete.php");
		?>
		  <div style="text-align:center;">
		  <table class="cadrearticle" width="90%" cellpadding="10" cellspacing="0">
			<tr>
			  <td align="center" style="text-align:left">
	<br/><h1>Les listes doublement chanes en C</h1><p class="dateArticle">
		Date de publication : 20 Juillet 2005</p><p style="text-align: center;">
        Par
        <a class="auteur" href="http://www.developpez.net/forums/member.php?u=41072">Nicolas Joseph</a> <a class="homepage" href="http://nicolasj.developpez.com"> (home)</a><br/>&nbsp;</p><div class="synopsis">
		Les structures de donnes en C.
		 les listes doublement chanes.
	</div>
		<br /><a class="summaryIndent0" href="#LI">I. Introduction</a>
			
			
		
		<br /><a class="summaryIndent0" href="#LII">II. Principe</a>
			
			
			
			
			
			
		
		<br /><a class="summaryIndent0" href="#LIII">III. La pratique</a>
			
			<br /><a class="summaryIndent1" href="#LIII-A">III-A. La structure d'un maillon</a>
				
				

			
			<br /><a class="summaryIndent1" href="#LIII-B">III-B. Initialisation</a>
				
				


			
			<br /><a class="summaryIndent1" href="#LIII-C">III-C. Insertion d'un lment</a>
				
				
						
				
				

					
			<br /><a class="summaryIndent1" href="#LIII-D">III-D. Suppression d'un lment</a>
				
				
				
				

			
			<br /><a class="summaryIndent1" href="#LIII-E">III-E. Accs  l'lment prcdent</a>
				
				

			
			<br /><a class="summaryIndent1" href="#LIII-F">III-F. Accs au premier lment</a>
				
				
		
			
			<br /><a class="summaryIndent1" href="#LIII-G">III-G. Suppression de la liste</a>
				
				

			
			
		<br /><a class="summaryIndent0" href="#LIV">IV. Conclusion</a>
			
			
		
		<br /><a class="summaryIndent0" href="#LV">V. Autres documentations</a>
			
			
			
		<br /><a class="summaryIndent0" href="#LVI">VI. Remerciements</a>
			
			
			
		<br /><a class="summaryIndent0" href="#LVII">VII. Code source complet</a>
			
			



		
	<br/><br/>
		<br /><h1 class="TitreSection0" id="LI">I. Introduction</h1>
			
			<div class="paragraph">
				Aprs avoir vu les listes simplement chanes, pour cette seconde partie, nous allons nous attarder sur les listes doublement chanes.
			</div><br/>
		
		<br /><h1 class="TitreSection0" id="LII">II. Principe</h1>
			
			<div class="paragraph">
				A la diffrence des listes simplement chanes, les maillons d'une liste doublement chane possdent un pointeur sur l'lment qui les prcdent :
			</div><br/>
			<div class="image" style="text-align:center;"><img src="./images/fig1.gif" alt="Reprsentation d'un lment d'une liste doublement chane."/><div style="text-align:center;" class="legimage">Figure 1 : reprsentation d'un lment d'une liste doublement chane.</div></div>
			<div class="paragraph">
				Le fait d'avoir accs  l'lment prcdent va nous permettre de simplifier les fonctions de la bibliotque prcdente :
			</div><br/>
			<ul style="list-style-type: disc;">
				<li>Il n'est plus ncessaire d'utiliser une sentinnelle pour retrouver le premier lment de la liste ce qui permet de se passer de la structure qui englobait la liste simplement chane</li>
				<li>L'insertion d'un lment peut se faire aussi bien avant qu'aprs celui pass en paramtre de la fonction</li>
				<li>Il est maintenant possible de supprimer l'lment pass en paramtre et non plus le suivant</li>
				<li>Il faut une fonction qui retourne le maillon prcdent</li>
			</ul>
			<div class="paragraph">
				A part ces quelques points, les fonctions ont un fonctionnement identique.
			</div><br/>
		
		<br /><h1 class="TitreSection0" id="LIII">III. La pratique</h1>
			
			<br /><h2 class="TitreSection1" id="LIII-A">III-A. La structure d'un maillon</h2>
				
				<div class="paragraph">
					Pour obtenir la structure de base d'une liste doublement chane, il suffit d'ajouter un pointeur sur l'lment prcedent  la structure <i>item_s</i> vue dans l'article prcdent. Comme la sentinelle est devenue inutile, il n'est plus ncessaire de crer une structure d'encapsidation de la liste.
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code">stypedef <span class="c_keyword">struct</span> dll
{
   <span class="c_keyword">struct</span> dll *prev;
   <span class="c_keyword">struct</span> dll *next;
   <span class="c_type">void</span> *data;
} dll_s;</span></pre></td></tr></table></div>
			
			<br /><h2 class="TitreSection1" id="LIII-B">III-B. Initialisation</h2>
				
				<div class="paragraph">
					L'initialisation de la liste est devenue inutile, cependant la fonction est conserve pour tre sr que le pointeur est mis  NULL :
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code">dll_s *dll_new (<span class="c_type">void</span>)
{
   <span class="c_keyword">return</span> (<span class="c_keyword">NULL</span>);
}</span></pre></td></tr></table></div>

			
			<br /><h2 class="TitreSection1" id="LIII-C">III-C. Insertion d'un lment</h2>
				
				<div class="paragraph">
					Le principe est identique  celui des listes simplement chane, il ne faut pas oublier de mettre  jour le pointeur sur l'lment prcdent.
				</div><br/>
				<div class="image" style="text-align:center;"><img src="./images/fig2.gif" alt="Reprsentation de l'insertion d'un lment."/><div style="text-align:center;" class="legimage">Figure 2 : reprsentation de l'insertion d'un lment.</div></div>		
				<ol style="list-style-type: decimal;">
					<li>Voici l'tat de la liste avant l'appel de la fonction</li>
					<li>Le pointeur <i>p_p</i> reprsente l'argument de la fonction, c'est donc aprs lui qu'il faut insrer un maillon</li>
					<li><i>p_n</i> pointe sur l'lment qui suit</li>
					<li>Cration d'un nouvel lment point par <i>p_l</i></li>
					<li>On commence par faire pointer le nouvel lment sur le maillon qui suit <i>p_p</i> (donc <i>p_n</i>) sans oublier de faire pointer ce dernier vers notre nouvel lment puisque maintenant la liste va dans les deux sens</li>
					<li>Puis l'on modifie <i>p_p</i> pour que l'lment qui le suit soit celui nouvellement cr et rciproquement</li>
					<li>Etat de la liste aprs l'appel de la fonction</li>
				</ol>
				<div class="paragraph">
					Le code est lgrement diffrent du fait de l'absence de la structure d'encapsulation.
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">void</span> dll_insert (dll_s ** pp_dll, <span class="c_type">void</span> *data)
{
   <span class="c_keyword">if</span> (pp_dll != <span class="c_keyword">NULL</span>)
   {
<span class="c_comment">/* (2) */</span>
      dll_s *p_p = *pp_dll;
      dll_s *p_l = <span class="c_keyword">NULL</span>;
      dll_s *p_n = <span class="c_keyword">NULL</span>;

<span class="c_comment">/* (3) */</span>
      <span class="c_keyword">if</span> (p_p != <span class="c_keyword">NULL</span>)
         p_n = p_p-&gt;next;
<span class="c_comment">/* (4) */</span>
      p_l = malloc (<span class="c_keyword">sizeof</span> (*p_l));
      <span class="c_keyword">if</span> (p_l != <span class="c_keyword">NULL</span>)
      {
         p_l-&gt;data = data;
<span class="c_comment">/* (5) */</span>
         p_l-&gt;next = p_n;
         <span class="c_keyword">if</span> (p_n != <span class="c_keyword">NULL</span>)
            p_n-&gt;prev = p_l;
<span class="c_comment">/* (6) */</span>
         p_l-&gt;prev = p_p;
         <span class="c_keyword">if</span> (p_p != <span class="c_keyword">NULL</span>)
            p_p-&gt;next = p_l;
         *pp_dll = p_l;
      }
      <span class="c_keyword">else</span>
      {
         fprintf (stderr, <span class="c_ch">"Memoire insuffisante\n"</span>);
         exit (EXIT_FAILURE);
      }
   }
}</span></pre></td></tr></table></div>
					
			<br /><h2 class="TitreSection1" id="LIII-D">III-D. Suppression d'un lment</h2>
				
				<div class="paragraph">
					Voici la fonction qui va subir le plus de modifications, elle va ainsi pouvoir supprimer l'lment passer en paramtre.
				</div><br/>
				<div class="image" style="text-align:center;"><img src="./images/fig3.gif" alt="Reprsentation de la suppression d'un lment."/><div style="text-align:center;" class="legimage">Figure 3 : reprsentation de la suppression d'un lment.</div></div>
				<ol style="list-style-type: decimal;">
					<li>Voici l'tat de la liste avant l'appel de la fonction</li>
					<li>Le pointeur <i>p_l</i> reprsente l'argument de la fonction et donc l'lment  supprimer</li>
					<li>Sauvegarde de l'lment prcdent celui  supprimer grce au pointeur <i>p_p</i></li>
					<li>Sauvegarde de l'lment suivant celui  supprimer grce au pointeur <i>p_n</i></li>
					<li>Modification des pointeurs de telle manire que le maillon  supprimer ne soit plus rfrenc</li>
					<li>Libration de la mmoire</li>
					<li>tat de la liste aprs l'appel de la fonction</li>
				</ol>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">void</span> dll_remove (dll_s ** pp_dll)
{
   <span class="c_keyword">if</span> (pp_dll != <span class="c_keyword">NULL</span> &amp;&amp; *pp_dll != <span class="c_keyword">NULL</span>)
   {
<span class="c_comment">/* (2) */</span>
      dll_s *p_l = *pp_dll;
<span class="c_comment">/* (3) */</span>
      dll_s *p_p = p_l-&gt;prev;
<span class="c_comment">/* (4) */</span>
      dll_s *p_n = p_l-&gt;next;

<span class="c_comment">/* (5) */</span>
      <span class="c_keyword">if</span> (p_p != <span class="c_keyword">NULL</span>)
         p_p-&gt;next = p_n;
      <span class="c_keyword">if</span> (p_n != <span class="c_keyword">NULL</span>)
         p_n-&gt;prev = p_p;
<span class="c_comment">/* (6) */</span>
      free (p_l);
      p_l = <span class="c_keyword">NULL</span>;
      <span class="c_keyword">if</span> (p_n != <span class="c_keyword">NULL</span>)
         *pp_dll = p_n;
      <span class="c_keyword">else</span>
         *pp_dll = p_p;
   }
}</span></pre></td></tr></table></div>
			
			<br /><h2 class="TitreSection1" id="LIII-E">III-E. Accs  l'lment prcdent</h2>
				
				<div class="paragraph">
					Cette fonction se contente de dplacer le pointeur sur l'lment qui prcdent, en faisant tout de mme attention  la valeur de <i>pp_dll</i> : 
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">void</span> dll_prev (dll_s ** pp_dll)
{
   <span class="c_keyword">if</span> (pp_dll != <span class="c_keyword">NULL</span> &amp;&amp; *pp_dll != <span class="c_keyword">NULL</span>)
      *pp_dll = (*pp_dll)-&gt;prev;
}</span></pre></td></tr></table></div>
			
			<br /><h2 class="TitreSection1" id="LIII-F">III-F. Accs au premier lment</h2>
				
				<div class="paragraph">
					Avec l'apparition du pointeur sur l'lment prcdent, la sentinelle qui reprait le premier lment de la liste n'existe plus, ce qui a permis de simplifier certaines fonctions, cependant il faut retrouver ce premier lment de la mme manire que le dernier lment.
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">void</span> dll_first (dll_s ** pp_dll)
{
   <span class="c_keyword">if</span> (pp_dll != <span class="c_keyword">NULL</span> &amp;&amp; *pp_dll != <span class="c_keyword">NULL</span>)
   {
      <span class="c_keyword">while</span> ((*pp_dll)-&gt;prev != <span class="c_keyword">NULL</span>)
         dll_prev (pp_dll);
   }
}</span></pre></td></tr></table></div>		
			
			<br /><h2 class="TitreSection1" id="LIII-G">III-G. Suppression de la liste</h2>
				
				<div class="paragraph">
					Comme la fonction de suppression des lments a t modifie, il est logique qu'il en soit de mme pour la destruction de la liste.
				</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="code"><pre><span class="c_code"><span class="c_type">void</span> dll_delete (dll_s ** pp_dll)
{
   <span class="c_keyword">if</span> (pp_dll != <span class="c_keyword">NULL</span> &amp;&amp; *pp_dll != <span class="c_keyword">NULL</span>)
   {
      dll_first (pp_dll);
      <span class="c_keyword">while</span> (*pp_dll != <span class="c_keyword">NULL</span>)
         dll_remove (pp_dll);
   }
}</span></pre></td></tr></table></div>
			
			
		<br /><h1 class="TitreSection0" id="LIV">IV. Conclusion</h1>
			
			<div class="paragraph">
				Comme pour les listes simplement chanes, si vous cherchez d'autres fonctions, il y a celles de la <a href="http://developer.gnome.org/doc/API/2.0/glib/index.html" class="lienArticle">glib</a>. Maintenant que nous avons fait le tour des listes chanes, les deux prochains articles porteront sur des cas particuliers de liste chanes : les piles et les files.
			</div><br/>
		
		<br /><h1 class="TitreSection0" id="LV">V. Autres documentations</h1>
			
			<div class="paragraph">
				<img src="http://www.developpez.be/images/kitfr.jpg" alt="fr"/>&nbsp;<a href="http://chgi.developpez.com/dblist/" class="lienArticle">Liste doublement chane par CGI</a>
			</div><br/>
			
		<br /><h1 class="TitreSection0" id="LVI">VI. Remerciements</h1>
			
			<div class="paragraph">
				Merci  Anomaly pour sa relecture attentive de cet article.
			</div><br/>
			
		<br /><h1 class="TitreSection0" id="LVII">VII. Code source complet</h1>
			
			<div class="paragraph">
				Les exemples d'utilisation des listes doublements chanes ne manquent pas puisqu'elles sont prsentes dans les entrailles des systmes d'exploitation (pour la gestion de la mmoire) jusqu'aux applications courantes (pour le tri des donnes par exemple). Tlchargez l'<a href="ftp://www.ftp-developpez.com/nicolasj/listedouble.zip" class="lienArticle">archive zippe</a>.
			</div>
<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="titre_code">listedouble.h</td></tr><tr><td class="code"><pre><span class="c_code"><span class="c_define">#ifndef H_LISTEDOUBLE</span>
<span class="c_define">#define H_LISTEDOUBLE</span>

<span class="c_define">#include &lt;stddef.h&gt;             /* pour size_t */</span>

<span class="c_keyword">typedef</span> <span class="c_keyword">struct</span> dll dll_s;

dll_s *dll_new (<span class="c_type">void</span>);
<span class="c_type">void</span> dll_insert (dll_s **, <span class="c_type">void</span> *);
<span class="c_type">void</span> dll_remove (dll_s **);
<span class="c_type">void</span> dll_prev (dll_s **);
<span class="c_type">void</span> dll_next (dll_s **);
<span class="c_type">void</span> *dll_data (dll_s *);
<span class="c_type">void</span> dll_first (dll_s **);
<span class="c_type">void</span> dll_last (dll_s **);
size_t dll_sizeof (dll_s *);
<span class="c_type">void</span> dll_delete (dll_s **);

<span class="c_define">#endif /* not H_LISTEDOUBLE */</span></span></pre></td></tr></table></div>

<div style="text-align:center;"><table style="width:90%;margin:10px auto;border-collapse: collapse;"><tr><td class="titre_code">listedouble.c</td></tr><tr><td class="code"><pre><span class="c_code"><span class="c_define">#include &lt;stdio.h&gt;</span>
<span class="c_define">#include &lt;stdlib.h&gt;</span>
<span class="c_define">#include "listedouble.h"</span>

<span class="c_keyword">struct</span> dll
{
   <span class="c_keyword">struct</span> dll *prev;
   <span class="c_keyword">struct</span> dll *next;
   <span class="c_type">void</span> *data;
};

dll_s *dll_new (<span class="c_type">void</span>)
{
   <span class="c_keyword">return</span> (<span class="c_keyword">NULL</span>);
}

<span class="c_type">void</span> dll_insert (dll_s ** pp_dll, <span class="c_type">void</span> *data)
{
   <span class="c_keyword">if</span> (pp_dll != <span class="c_keyword">NULL</span>)
   {
      dll_s *p_p = *pp_dll;
      dll_s *p_l = <span class="c_keyword">NULL</span>;
      dll_s *p_n = <span class="c_keyword">NULL</span>;

      <span class="c_keyword">if</span> (p_p != <span class="c_keyword">NULL</span>)
         p_n = p_p-&gt;next;
      p_l = malloc (<span class="c_keyword">sizeof</span> (*p_l));
      <span class="c_keyword">if</span> (p_l != <span class="c_keyword">NULL</span>)
      {
         p_l-&gt;data = data;
         p_l-&gt;next = p_n;
         <span class="c_keyword">if</span> (p_n != <span class="c_keyword">NULL</span>)
            p_n-&gt;prev = p_l;
         p_l-&gt;prev = p_p;
         <span class="c_keyword">if</span> (p_p != <span class="c_keyword">NULL</span>)
            p_p-&gt;next = p_l;
         *pp_dll = p_l;
      }
      <span class="c_keyword">else</span>
      {
         fprintf (stderr, <span class="c_ch">"Memoire insuffisante\n"</span>);
         exit (EXIT_FAILURE);
      }
   }
}

<span class="c_type">void</span> dll_remove (dll_s ** pp_dll)
{
   <span class="c_keyword">if</span> (pp_dll != <span class="c_keyword">NULL</span> &amp;&amp; *pp_dll != <span class="c_keyword">NULL</span>)
   {
      dll_s *p_l = *pp_dll;
      dll_s *p_p = p_l-&gt;prev;
      dll_s *p_n = p_l-&gt;next;

      <span class="c_keyword">if</span> (p_p != <span class="c_keyword">NULL</span>)
         p_p-&gt;next = p_n;
      <span class="c_keyword">if</span> (p_n != <span class="c_keyword">NULL</span>)
         p_n-&gt;prev = p_p;
      free (p_l);
      p_l = <span class="c_keyword">NULL</span>;
      <span class="c_keyword">if</span> (p_n != <span class="c_keyword">NULL</span>)
         *pp_dll = p_n;
      <span class="c_keyword">else</span>
         *pp_dll = p_p;
   }
}

<span class="c_type">void</span> dll_next (dll_s ** pp_dll)
{
   <span class="c_keyword">if</span> (pp_dll != <span class="c_keyword">NULL</span> &amp;&amp; *pp_dll != <span class="c_keyword">NULL</span>)
      *pp_dll = (*pp_dll)-&gt;next;
}

<span class="c_type">void</span> dll_prev (dll_s ** pp_dll)
{
   <span class="c_keyword">if</span> (pp_dll != <span class="c_keyword">NULL</span> &amp;&amp; *pp_dll != <span class="c_keyword">NULL</span>)
      *pp_dll = (*pp_dll)-&gt;prev;
}

<span class="c_type">void</span> *dll_data (dll_s * p_dll)
{
   <span class="c_keyword">return</span> ((p_dll != <span class="c_keyword">NULL</span>) ? p_dll-&gt;data : <span class="c_keyword">NULL</span>);
}

<span class="c_type">void</span> dll_first (dll_s ** pp_dll)
{
   <span class="c_keyword">if</span> (pp_dll != <span class="c_keyword">NULL</span> &amp;&amp; *pp_dll != <span class="c_keyword">NULL</span>)
   {
      <span class="c_keyword">while</span> ((*pp_dll)-&gt;prev != <span class="c_keyword">NULL</span>)
         dll_prev (pp_dll);
   }
}

<span class="c_type">void</span> dll_last (dll_s ** pp_dll)
{
   <span class="c_keyword">if</span> (pp_dll != <span class="c_keyword">NULL</span> &amp;&amp; *pp_dll != <span class="c_keyword">NULL</span>)
   {
      <span class="c_keyword">while</span> ((*pp_dll)-&gt;next != <span class="c_keyword">NULL</span>)
         dll_next (pp_dll);
   }
}

size_t dll_sizeof (dll_s * p_dll)
{
   size_t n = 0;

   <span class="c_keyword">if</span> (p_dll != <span class="c_keyword">NULL</span>)
   {
      dll_first (&amp;p_dll);
      <span class="c_keyword">while</span> (p_dll != <span class="c_keyword">NULL</span>)
      {
         n++;
         dll_next (&amp;p_dll);
      }
   }
   <span class="c_keyword">return</span> (n);
}

<span class="c_type">void</span> dll_delete (dll_s ** pp_dll)
{
   <span class="c_keyword">if</span> (pp_dll != <span class="c_keyword">NULL</span> &amp;&amp; *pp_dll != <span class="c_keyword">NULL</span>)
   {
      dll_first (pp_dll);
      <span class="c_keyword">while</span> (*pp_dll != <span class="c_keyword">NULL</span>)
         dll_remove (pp_dll);
   }
}</span></pre></td></tr></table></div>
		
	<br/><?include("http://nicolasj.developpez.com/articles/structures.inc");?><hr/><p style="text-align:center;"><a href="http://validator.w3.org/check?uri=referer"><img src="http://www.w3.org/Icons/valid-xhtml11" alt="Valid XHTML 1.1!" height="31" width="88"/></a><a href="http://jigsaw.w3.org/css-validator/check/referer"><img style="border:0;width:88px;height:31px" src="http://jigsaw.w3.org/css-validator/images/vcss" alt="Valid CSS!"/></a></p><div id="xiti-logo" style="text-align:center;">
<a href="http://www.xiti.com/xiti.asp?s=205564" title="Mesurez votre audience">
<script type="text/javascript">
<!--
Xt_param = 's=205564&p=articles/listedouble';
Xt_r = document.referrer;
Xt_h = new Date();
Xt_i = '<img width="39" height="25" border="0" ';
Xt_i += 'src="http://logv28.xiti.com/hit.xiti?'+Xt_param;
Xt_i += '&hl='+Xt_h.getHours()+'x'+Xt_h.getMinutes()+'x'+Xt_h.getSeconds();
if(parseFloat(navigator.appVersion)>=4)
{Xt_s=screen;Xt_i+='&r='+Xt_s.width+'x'+Xt_s.height+'x'+Xt_s.pixelDepth+'x'+Xt_s.colorDepth;}
document.write(Xt_i+'&ref='+Xt_r.replace(/[<>"]/g, '').replace(/&/g, '$')+'" title="Analyse d\'audience">');
//-->
</script>
<object>
<noscript>
<div id="xiti-logo-noscript-205564">
Mesure d'audience ROI frequentation par <img width="39" height="25" src="http://logv28.xiti.com/hit.xiti?s=205564" alt="Analyse d'audience" />
</div>
</noscript>
</object>
</a></div>
	  </td>
		</tr>
		   </table></div>
<?
	include("$DOCUMENT_ROOT/template/pied.php");?>